{$MODE objfpc}{$H+}
uses
  SysUtils, StrUtils;

function IsSegmented(const s: String): Boolean;
var
  i: Integer;
begin
  for i := 1 to Length(s) div 2 do
    if s = DupeString(LeftStr(s, i), Length(s) div i) then
      exit(true);
  Result := false;
end;

const F: array [1..8] of String = (
    'dmyyyy', 'ddmyyyy', 'dmmyyyy', 'ddmmyyyy',
    'dmyy', 'ddmyy', 'dmmyy', 'ddmmyy'
);
var
  d, m, y, i: Integer;
  c: TDateTime;
  s: String;
begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Read(d, m, y);
  c := EncodeDate(y, m, d);
  while true do begin
    for i := 1 to 8 do begin
      s := FormatDateTime(F[i], c);
      if (s = ReverseString(s)) or IsSegmented(s) then begin
        Writeln(FormatDateTime('d m yyyy', c));
        Halt;
      end;
    end;
    c += 1;
  end;
end.
