#include <string>
#include <iostream>
#include <sstream>
#include <algorithm>

using namespace std;

const int a[] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

int d, m, y;

void inc()
{
   d++;
   int maxm = a[m] + (m == 2 && (!(y%4) && ((y%100) || !(y%400))) ? 1 : 0);
   if (d > maxm) {
      m++; d = 1;
      if (m > 12) {
         y++; m = 1;
      }
   }
}

int chk(string s)
{
   int i, j, k, n = s.length();
   string s1;
   for (i = 0; i < n; i++) s1 = s[i] + s1;
   if (s1 == s) return 1;
   
   for (k = 1; k < n; k++)
      if (!(n%k)) {
         int ok = 1;
         for (j = k; j < n; j++)
            if (s[j] != s[j%k]) ok = 0;
         if (ok) return 1;
      }
   
   return 0;
}

int nice()
{
   ostringstream s[4], x[2];
   s[0] << d << m;
   s[1] << (d < 10 ? "0" : "") << d << m;
   s[2] << d << (m < 10 ? "0" : "") << m;
   s[3] << (d < 10 ? "0" : "") << d << (m < 10 ? "0" : "") << m;
   x[0] << y;
   x[1] << (y%100)/10 << y%10;

   int res = 0;
   for (int i = 0; i < 2; i++)
      for (int j = 0; j < 4; j++)
         res = res || chk(s[j].str() + x[i].str());
   return res;
}

int main()
{
   freopen("input.txt" ,"rt", stdin); freopen("output.txt", "wt", stdout);
   
   cin >> d >> m >> y;
   
   while (!nice()) inc();
   
   cout << d << " " << m << " " << y;

   fclose(stdin); fclose(stdout);
   return 0;   
}
